/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	gekrzte AES-Routinen
 */

#include <xlb.h>

static short w_update=0;
static short w_mctrl=0;

/* Bildschirm fr eigene Ausgaben reservieren */
void begin_update(void)
{
	if (wind_update(BEG_UPDATE)!=0)
		w_update++;
}

/* Bildschirmreservierung zurcknehmen */
void end_update(void)
{
	if (w_update)
	{
		wind_update(END_UPDATE);
		w_update--;
	}
}

/* Mauskontrolle bernehmen */
void begin_mctrl(void)
{
	if (wind_update(BEG_MCTRL)!=0)
		w_mctrl++;
}

/* Mauskontrolle zurckgeben */
void end_mctrl(void)
{
	if (w_mctrl)
	{
		wind_update(END_MCTRL);
		w_mctrl--;
	}
}

/* alle wind_update's lschen */
void clear_update(void)
{
	while (w_update)
		end_update();
	while (w_mctrl)
		end_mctrl();
}


/* Maus verstecken */
void hide_mouse(void)
{
	graf_mouse(M_OFF,0L);
}

/* testen, ob Maus innerhalb des Rechtecks rect liegt, und dann verstecken */
boolean hide_mouse_inside(GRECT *rect)
{
	int mx,my,dummy;
	GRECT xrect=*rect;
	graf_mkstate(&mx,&my,&dummy,&dummy);
	xrect.g_x-=16;
	xrect.g_y-=16;
	xrect.g_w+=32;
	xrect.g_h+=32;
	if (rc_inside(mx,my,&xrect)) {
		hide_mouse();
		return TRUE;
	}
	return FALSE;
}

/* Maus zeigen */
void show_mouse(void)
{
	graf_mouse(M_ON,0L);
}

/* Mauszeiger darstellen */
void arrow_mouse(void)
{
	graf_mouse(ARROW,0L);
}

/* Biene darstellen */
void busybee_mouse(void)
{
	graf_mouse(BUSYBEE,0L);
}


/* Sanduhr darstellen */
void hourglas_mouse(void)
{
	static short hourglas[]={	7,7,1,0,1,
		16380,32766,32766,32766,16380,8184,4080,0x07E0,
		0x07E0,4080,8184,16380,32766,0xFFFF,0xFFFF,32766,
		0,4080,4104,4104,3024,2016,960,384,
		384,576,1056,2448,5064,10212,16380,0 };
	graf_mouse(USER_DEF,hourglas);
}


/* Handle des obersten Fensters ermitteln */
short wind_top(void)
{
	int i,wh;
	wind_get(0,WF_TOP,&wh,&i,&i,&i);
	return (short)wh;
}

/* VDI-Handle der AES ermitteln */
int aes_vhandle(void)
{
	int dummy;
	return graf_handle(&dummy,&dummy,&dummy,&dummy);
}

