/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 04/96
 *	Public Domain / Freeware
 *
 *	Cookies abfragen, setzen, lschen
 */

#include <osbind.h>
#include <xlb.h>

#ifndef NULL
# define NULL ((void*)0L)
#endif

typedef struct
{
	long cookie;
	long value;
} COOKIE;

#define _p_cookies	(*(COOKIE **)0x5a0)


/* Zeiger auf Cookie-Jar ermitteln */
static COOKIE* getckp(void)
{
	register COOKIE *p;
	long oldstack=Super(0L);
	p=_p_cookies;
	Super((void*)oldstack);
	return p;
}

/* Anzahl der vorhandenen und der mglichen Cookies ermitteln,
   Zeiger auf letzen Cookie (0-Cookie) zurckgeben */
static COOKIE* getcklen(short *creal,short *cmax)
{
	register COOKIE *p=getckp();
	register short ii=0;
	if (p) {
		while (p->cookie) {
			p++;
			ii++;
		}
		if (cmax)
			*cmax=p->value;
		if (creal)
			*creal=ii;
		return p;
	}
	return NULL;
}

/* Cookiekennung suchen und bei Erfolg Adresse zurckgeben */
static COOKIE* getck(long cookie)
{
	register COOKIE *p=getckp();
	if (p)
		while (p->cookie) {
			if (p->cookie==cookie)
				return p;
			p++;
		}
	return NULL;
}

/* Wert eines Cookie ermitteln */
boolean getcookie(long cookie,long *value)
{
	register COOKIE *p=getck(cookie);
	if (p) {
		if (value)
			*value=p->value;
		return TRUE;
	}
	return FALSE;
}

/* Wert eines Cookie neu setzen, bzw. neuen Cookie eintragen,
   sofern Platz ist! */
boolean putcookie(long cookie,long value)
{
	short creal,cmax;
	register COOKIE *p=getck(cookie);
	if (p) {
		p->value=value;
		return TRUE;
	}
	p=getcklen(&creal,&cmax);
	if (creal<cmax-1) {
		p[1]=*p;
		p->cookie=cookie;
		p->value=value;
		return TRUE;
	}
	return FALSE;
}

/* Cookie lschen */
boolean rmvcookie(long cookie)
{
	register COOKIE *p=getck(cookie);
	if (p) {
		while (p->cookie) {
			*p=p[1];
			p++;
		}
	}
	return FALSE;
}
