/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96, 04/96
 *	Public Domain / Freeware
 *
 *	DOS-Pfad erfragen oder setzen
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <osbind.h>
#include <ctype.h>
#include <xlb.h>

extern volatile int errno;

/*	aktuelles Laufwerk erfragen	*/
short getdrive(void)
{
	return Dgetdrv();
}

/*	aktuellen Pfad erfragen,selfmade	*/
void xgetpath(short drive,char* path)
{
	if (drive<0)
		drive=getdrive();
	path[0]=drive+65;
	path[1]=':';
	Dgetpath(&path[2],drive+1);
	strcatc(path,'\\');
}

/* aktuellen Pfad ermitteln, Lattice C, UNIX */
char *getcwd(char *b,size_t size)
{
	if (b==NULL) {
		b=(char*)malloc(PATH_MAX);
		if (b==NULL)
			return NULL;
		getpath(b);
	} else {
		char path[PATH_MAX];
		getpath(path);
		if (strlen(path)<=size)
			strcpy(b,path);
		else {
			errno=1;
			return NULL;
		}
	}
	return b;
}

/* aktuelles Laufwerk setzen, selfmade	*/
void setdrive(short dr)
{
	Dsetdrv(dr);
}

/*	aktuellen Pfad setzen, selfmade	*/
void setpath(char* path)
{
	if ((*path) && (path[1]==':'))
		setdrive(_toupper(path[0])-65);
	Dsetpath(path);
}


/* Laufwerks-Bitvektor zurckgeben, selfmade */
long drives(void)
{
	return Dsetdrv(Dgetdrv());
}

/* Laufwerk auf Existenz prfen, selfmade */
boolean tstdrive(short dr)
{
	return (btstl(drives(),dr));
}

/* Laufwerksbuchstaben auf Existenz prfen, selfmade */
boolean tstdrivec(char c)
{
	return tstdrive(_toupper(c)-'A');
}


int mkdir(char *path)
{
	return Dcreate(path);
}

int rmdir(char *path)
{
	return Ddelete(path);
}
