/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 05/96
 *	Public Domain / Freeware
 *
 *	GEMDOS-Datei-Operationen
 */

#include <stdio.h>
#include <string.h>
#include <osbind.h>
#include <xlb.h>


/*	Daten schreiben, vgl. ANSI */

long Fputs(char *s,int handle)
{
	return Fwrite(handle,strlen(s)+1,s);
}

long Fputc(char c,int handle)
{
	return Fwrite(handle,1L,&c);
}

long Fputw(short w,int handle)
{
	return Fwrite(handle,2L,&w);
}

long Fputl(long l,int handle)
{
	return Fwrite(handle,4L,&l);
}


/*	Daten laden, vgl. ANSI */

long Fgetc(int handle)
{
	char c;
	if (Fread(handle,1L,&c)!=1L)
		return EOF;
	return (long)c;
}

char *Fgets(char *buffer,int length,int handle)
{
	long c;
	int ii=0;
	do {
		c=Fgetc(handle);
		if (c==EOF) {
			buffer[ii]='\0';
			return NULL;
		}
		buffer[ii++]=(char)c;
	} while ((c) && (ii<length));
	return buffer;
}

short Fgetw(int handle)
{
	short w;
	if (Fread(handle,2L,&w)!=2L)
		return EOF;
	return w;
}

long Fgetl(int handle)
{
	long l;
	if (Fread(handle,4L,&l)!=4L)
		return EOF;
	return l;
}


/*	Dateizeiger	*/

/* Zeigerposition ermitteln */
int Fgetpos(int handle,long *pos)
{
	*pos=Fseek(0L,handle,1);
	if (*pos>=0L)
		return 0;
	return -1;
}

/* Zeiger positionieren */
int Fsetpos(int handle,long *pos)
{
	if (Fseek(*pos,handle,0)>=0L)
		return 0;
	return -1;
}

/* Prfen, ob Datei auf den Bildschirm umgelemkt wurde,
   siehe Profibuch unter Fseek() */
boolean isatty(int handle)
{
	long oldoffset,rc;
	oldoffset=Fseek(0L,handle,1);
	rc=Fseek(1L,handle,0);
	Fseek(oldoffset,handle,0);
	if (rc!=1)
		return TRUE;
	return FALSE;
}
