/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 04/96
 *	Public Domain / Freeware
 *
 *	fopen mit Environment-Suche
 */

#include <stdio.h>
#include <stdlib.h>
#include <osbind.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include <xlb.h>

/* versuchen die Datei name zu ffnen, selfmade */
boolean fileexist(char *name)
{
#ifdef USE_UNIX
	int fh=open(name,O_RDONLY,0);
	if (fh<=0)
		return FALSE;
	close(fh);
	return TRUE;
#else
	int fh=Fopen(name,0);
	if (fh<=0)
		return FALSE;
	Fclose(fh);
	return TRUE;
#endif
}

/* testen on Datei p existiert und dann mit mode ffnen, Pfad nach
   path kopieren und Speicher p freigeben */
static FILE* doexiting(char *p,char *mode,char *path)
{
	FILE *fp;
	if (fileexist(p)==TRUE) {
		if (path)
			stcgfp(path,p);
		fp=fopen(p,mode);
		if (fp) {
			free(p);
			fseek(fp,0,SEEK_SET);
			return fp;
		}
	}
	return NULL;
}

/* Environment-Variable env auswerten und versuchen Datei name mit mode
   zu ffnen, bei Erfolg Pfad nach path schreiben */
static FILE* testenv(char *env,char *name,char *mode,char *path)
{
	if (env) {
		char *p=(char*)malloc((long)PATH_MAX);
		if (p) {
			while (*env) {
				register char *pp=p;
				strclr(pp);
				while ((*env) && (*env!=',') && (*env!=';') && 
					((*env!=':') || ((pp==&p[1]) && (isalpha(*p)))))
					*pp++=*env++;
				if (*env)
					env++;
				strclr(pp);
				if (*p) {
					FILE *fp;
					strcatcs(p,'\\',name);
					fp=doexiting(p,mode,path);
					if (fp)
						return fp;
					if (p[1]!=':') {
						if ((*p!='\\') && (*p!='/'))
							strins(p,"\\");
						strins(p,"u:");
						fp=doexiting(p,mode,path);
						if (fp)
							return fp;
					}
				}	/* if *p */
			}	/* while *env */
			free(p);
		} /* if p */
	} /* if env */
	return NULL;
}

/* perform fopen with environment search, Lattice
   Datei name suchen: unter Pfad name, im aktuellen Verzeichnis, ber die
   Environmentvariable der Extension und ber Envvar PATH, bei Erfolg Datei
   mit mode ffnen, evtl. Pfad nach path schreiben und FILE* zurckgeben */
FILE *fopene(char *name,char *mode,char *path)
{
	if (path)
		strclr(path);
	if (fileexist(name))
		return fopen(name,mode);
	if ((*name=='/') || (*name=='\\') || (name[1]==':'))
		return NULL;
	{
		char nx[NAME_MAX];
		FILE *fp;
		stcgfe(nx,name);
		if (*nx) {
			fp=testenv(xgetenv(strupper(nx)),name,mode,path);
			if (fp)
				return fp;
		}
		stcgfn(nx,name);
		stcwoe(nx,nx);
		fp=testenv(xgetenv(strupper(nx)),name,mode,path);
		if (fp)
			return fp;
		fp=testenv(xgetenv("PATH"),name,mode,path);
		if (fp)
			return fp;
	}
	return NULL;
}

/* flush all file output buffers, return numbers of open files,
   if error continue and return -1, Lattice */
int flushall(void)
{
	register int i, f, ret=0;
	for(i=0; i<_NFILE; ++i) {
		f = _iob[i]._flag;
		if (f & (_IORW | _IOREAD | _IOWRT)) {
			if (fflush(&_iob[i])==-1)
				ret=-1;
			if (ret>=0)
				ret++;
		}
	}
	return ret;
}


/* close all buffered files, return numbers of open files,
   if error continue and return -1, Lattice */
int fcloseall(void)
{
	register int i, f, ret=0;
	for(i=0; i<_NFILE; ++i) {
		f = _iob[i]._flag;
		if(f & (_IORW | _IOREAD | _IOWRT)) {
			if (_iob[i]._file <= 2) {	/* only flush std. streams */
				if (fflush(&_iob[i])==-1)
					ret=-1;
			}
			if (fclose(&_iob[i])==-1)
				ret=-1;
			if (ret>=0)
				ret++;
		}
	}
	return ret;
}
