/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	graf_??()-Aufrufe fr Hintergrundbedienung
 */

#include <macros.h>
#include <xlb.h>

static short gfbk_start(void)
{
	GRECT rect;
	short vh=v_opnvwk_screen();
	begin_update();
	begin_mouse();
	hide_mouse();
	if (!vh)
		vh=aes_vhandle();
	wind_gget(0,WF_WORKXYWH,&rect);
	vs_gclip(vh,&rect);
	vsf_color(vh,V_BLACK);
	vsf_interior(vh,FIS_HOLLOW);
	vsf_style(vh,0);
	vsf_perimeter(vh,1);
	vsl_color(vh,V_BLACK);
	vsl_width(vh,1);
	vsl_type(vh,LT_USERDEF);
	vsl_udsty(vh,0xCCCC);
	vswr_mode(vh,MD_XOR);
	return vh;
}

static void gfbk_end(short vh,short mb)
{
	evnt_debutton(mb);	/* Maustaste entprellen */
	vswr_mode(vh,MD_REPLACE);
	vs_clipoff(vh);
	if (vh!=aes_vhandle())
		v_clsvwk(vh);
	show_mouse();
	end_mouse();
	end_update();
}

/* dito graf_rubbox() nur ist auch die Benutzung der rechten Maustaste erlaubt! */
void gfbk_rubbox(short xor,short yor,short wmin,short hmin,short *wend,short *hend)
{
	short vh;
	static void rubbox(void)
	{
		v_box(vh,xor,yor,xor+*wend,yor+*hend);
	}
	int mbstart,mb,mx,my,dummy;
	vh=gfbk_start();
	graf_mkstate(&mx,&my,&mbstart,&dummy);
	*wend=mx-xor;
	*hend=my-yor;
	rubbox();
	do {
		mx=max(mx,xor+wmin);
		my=max(my,yor+hmin);
		if ((mx!=xor+*wend) || (my!=yor+*hend)) {
			rubbox();
			*wend=mx-xor;
			*hend=my-yor;
			rubbox();
		}
		graf_mkstate(&mx,&my,&mb,&dummy);
	} while (mbstart==mb);
	rubbox();
	gfbk_end(vh,mb);
}

/* dito graf_dragbox() nur ist auch die Benutzung der rechten Maustaste erlaubt! */
void gfbk_dragbox(short w,short h,short sx,short sy,
		short xc,short yc,short wc,short hc,short *dx,short *dy)
{
	short vh;
	static void dragbox(void)
	{
		v_box(vh,*dx,*dy,*dx+w,*dy+h);
	}
	int mbstart,mb,mx,my,dummy;
	vh=gfbk_start();
	graf_mkstate(&mx,&my,&mbstart,&dummy);
	*dx=sx;
	*dy=sy;
	sx=sx-mx;
	sy=sy-my;
	dragbox();
	do {
		if (((mx!=*dx-sx) && (sx+mx>=xc) && (sx+mx<=xc+wc-w))
			|| ((my!=*dy-sy) && (sy+my>=yc) && (sy+my<=yc+hc-h))) {
			dragbox();
			*dx=min(sx+mx,xc+wc-w);
			*dx=max(xc,*dx);
			*dy=min(sy+my,yc+hc-h);
			*dy=max(yc,*dy);
			dragbox();
		}
		graf_mkstate(&mx,&my,&mb,&dummy);
	} while (mbstart==mb);
	dragbox();
	gfbk_end(vh,mb);
}

/* dito graf_dragox() nur ist auch die Benutzung der rechten Maustaste
   erlaubt und es wird kein Auenrahmen bentigt! */
void gfbk_alldragbox(short w,short h,short sx,short sy,short *dx,short *dy)
{
	short vh;
	static void alldragbox(void)
	{
		v_box(vh,*dx,*dy,*dx+w,*dy+h);
	}
	int mbstart,mb,mx,my,dummy;
	vh=gfbk_start();
	graf_mkstate(&mx,&my,&mbstart,&dummy);
	*dx=sx;
	*dy=sy;
	sx=sx-mx;
	sy=sy-my;
	alldragbox();
	do {
		if ((mx!=*dx-sx) || (my!=*dy-sy)) {
			alldragbox();
			*dx=sx+mx;
			*dy=sy+my;
			alldragbox();
		}
		graf_mkstate(&mx,&my,&mb,&dummy);
	} while (mbstart==mb);
	alldragbox();
	gfbk_end(vh,mb);
}
