/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96, 07/96
 *	Public Domain / Freeware
 *
 *	Alternativen fr inline-Aufrufe
 *
 */

#include <xlb.h>

/*	rotate long value b bits to left	*/
long lrotl(long l,short b)
{
	return (l<<b)|(l>>(32-b));
}

/*	convert intel-short to motorola-short	*/
short intelshort(short x)
{
	return ((x&0xff)<<8)|((x&0xff00)>>8);
}

/*	convert intel-long to motorola-long	*/
long intellong(long x)
{
	register long ret=0L;
	register short ii;
	for(ii=0;ii<=2;ii++) {
		ret=(ret|(x&0xFFL))<<8;
		x>>=8;
	}
	return ret|x;
}

/*	multiply two short values to long result	*/
long imul(short a,short b)
{
	return ((long)a)*((long)b);
}

/*	divide long with short with result short	*/
short idiv(long a,short b)
{
	return (short) (a/((long)b));
}

/*	multiply two short and divide with short, internal long, result short	*/
short imuldiv(short a,short b,short c)
{
	return (short) ( (((long)a)*((long)b)) / ((long)c) );
}

/*	copy memory block of shorts and length len	*/
void memcpyw(short* to,short* from,short len)
{
	while (--len)
		to[len]=from[len];
}

/*	set bit b in short x	*/
short bset(short x,short b)
{
	return (x | (1<<b));
}

/*	set bit b in long x	*/
long bsetl(long x,short b)
{
	return (x | (1L<<b));
}

/*	set bit b in long value	*/
long bset1l(short b)
{
	return (1<<b);
}

/*	clear bit b in short x	*/
short bclr(short x,short b)
{
	return (x & (~(1<<b)));
}

/*	clear bit b in long x	*/
long bclrl(long x,short b)
{
	return (x & (~(1L<<b)));
}

/*	test bit b in short x	*/
boolean btst(short x,short b)
{
	if (x & (1<<b))
		return TRUE;
	return FALSE;
}

/*	test bit b in long x	*/
boolean btstl(long x,short b)
{
	if (x & (1L<<b))
		return TRUE;
	return FALSE;
}

/*	change bit b in short x	*/
short bchg(short x,short b)
{
	if (btst(x,b))
		return bclr(x,b);
	return bset(x,b);
}

/*	change bit b in long x	*/
long bchgl(long x,short b)
{
	if (btstl(x,b))
		return bclrl(x,b);
	return bsetl(x,b);
}

/*	count 1-bits in lower b bits of long x	*/
static short bits(long x,short b)
{
	register short ret=0;
	while (x) {
		if (x&1)
			ret++;
		x>>=1;
	}
	return ret;
}

/*	count 1-bits in long x	*/
short bitl(long x)
{
	return bits(x,32);
}

/*	count 1-bits in short x	*/
short bit(short x)
{
	return bits(x,16);
}
