/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	Tastatur-Konvertierung
 *	in Anlehnung an ST-Profibuch S. 759 ff
 */

#include <osbind.h>
#include <xlb.h>

typedef struct {
	char* unshift;
	char* shift;
	char* caps;
} KEYTABLE;

static KEYTABLE* kt=NULL;

unsigned short MapKey(short key)
{
	short keystate,asciicode;
	unsigned short ret=0,scancode;
	if (!kt) {
		kt=(KEYTABLE*)Keytbl((void*)-1L,(void*)-1L,(void*)-1L);
		if (((long)kt)<=0L)
			kt=NULL;
	}
	scancode=((key>>8)&0xff);
	asciicode=(key&0xff);
	keystate=(short)Kbshift(-1);
	if (asciicode>=0x20)	/* erstmal den VDI-Code verwenden */
		ret=asciicode;
	/* ALT & Ziffernblock */
	if (((keystate&KsALT)!=0)&&(scancode>=0x78)&&(scancode<=0x83))
		scancode-=0x76;
	/* passenden ASCII-Code suchen */
	if ((ret==0)&&(kt!=NULL)) {
		if (keystate&KsCAPS)
			ret=kt->caps[scancode];
		else if (keystate&KsSHIFT)
			ret=kt->shift[((scancode>=0x54)&&(scancode<=0x5d))?(scancode-0x19):scancode];
		else
			ret=kt->unshift[scancode];
	}
	/* shift left, ctrl left	*/
	if (((scancode==0x73)&&((keystate&KsCONTROL)!=0))||(scancode==0x4b))
		ret=KbLEFT;
	/* shift right, ctrl right */
	if (((scancode==0x74)&&((keystate&KsCONTROL)!=0))||(scancode==0x4d))
		ret=KbRIGHT;
	/* home */
	if (((scancode==0x77)&&((keystate&KsCONTROL)!=0))||(scancode==0x47))
		ret=KbHOME;
	/* up	*/
	if (scancode==0x48)
		ret=KbUP;
	/* down */
	if (scancode==0x50)
		ret=KbDOWN;
	/* insert */
	if (scancode==0x52)
		ret=KbINSERT;
	/* delete */
	if (scancode==0x53)
		ret=KbDELETE;
	/* wenn noch nicht passendes gefunden: Scancode zurck */
	if (!ret)
		ret=scancode|KbSCAN;
	/* Nummernblock vermerken */
	else if ((scancode==0x4a)||(scancode==0x4e)||((scancode>=0x63)&&(scancode<=0x72)))
		ret|=KbNUM;
	return (ret|(keystate<<8));
}
