/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	AES-Objekt-Verwaltung
 */

#include <xlb.h>

#ifndef LATTICE
void objc_xywh(OBJECT* tree,short objc,GRECT *rec)
{
	objc_offset(tree,(int)objc,&rec->g_x,&rec->g_y);
	rec->g_w=tree[objc].ob_width;
	rec->g_h=tree[objc].ob_height;
}
#endif

void drawobjc(OBJECT* tree,short objc)
{
	GRECT rec;
	objc_xywh(tree,objc,&rec);
	objc_draw(tree,objc,MAX_DEPTH,rec.g_x,rec.g_y,rec.g_w,rec.g_h);
}

void drawtree(OBJECT* tree,short objc)
{
	GRECT rec;
	objc_xywh(tree,objc,&rec);
	objc_draw(tree,objc,MAX_DEPTH,rec.g_x,rec.g_y,rec.g_w,rec.g_h);
}


void setobstr(OBJECT* tree,short objc,char* ob_str)
{
	OBJECT *o=&tree[objc];
	long spec;
#ifdef _XLB_GEMLIB37
	spec=o->ob_spec.index;
#else
	spec=o->ob_spec;
#endif
	switch(o->ob_type)
	{
		case G_STRING:
		case G_BUTTON:
		case G_TITLE:
			strcpy((char*)spec,ob_str);
			break;
		default:
			{
				register TEDINFO* ted=(TEDINFO*) spec;
				strncpy(ted->te_ptext,ob_str,(long)ted->te_txtlen-1);
			}
	}
}

void setobint(OBJECT* tree,short objc,int val)
{
	char s[10];
	if (val!=0)
		stci_d(s,val);
	else
		s[0]=0;
	setobstr(tree,objc,s);
}

void getobstr(OBJECT* tree,short objc,char *ob_str)
{
	OBJECT *o=&tree[objc];
	long spec;
#ifdef _XLB_GEMLIB37
	spec=o->ob_spec.index;
#else
	spec=o->ob_spec;
#endif
	switch(o->ob_type)
	{
		case G_STRING:
		case G_TITLE:
		case G_BUTTON:
			strcpy(ob_str,(char*)spec);
			break;
		default:
			strcpy(ob_str,((TEDINFO*)spec)->te_ptext);
	}
}

int getobint(OBJECT* tree,short objc)
{
	char s[10];
	int i;
	getobstr(tree,objc,s);
	stcd_i(s,&i);
	return(i);
}

void setobselect(OBJECT* tree,short objc,boolean state)
{
	if (state)
		tree[objc].ob_state|=SELECTED;
	else
		tree[objc].ob_state&=~SELECTED;
}

void setobdefault(OBJECT* tree,short objc,boolean state)
{
	register short* of=&tree[objc].ob_flags;
	if (state)
		*of|=DEFAULT;
	else
		*of&=(~DEFAULT);
}

boolean getobselect(OBJECT* tree,short objc)
{
	return(tree[objc].ob_state&SELECTED);
}

void setobdisable(OBJECT* tree,short objc,boolean mode)
{
	OBJECT *o;
	short *flags,*state;
	o=&tree[objc];
	flags=&o->ob_flags;
	state=&o->ob_state;
	if (mode)					/*	disable */
	{
		*flags&=~(TOUCHEXIT|SELECTABLE|EXIT);
		*state|=DISABLED;
	}
	else
	{
		*flags|=(TOUCHEXIT|SELECTABLE);
		*state&=~DISABLED;
	}
}
