/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 06/96
 *	Public Domain / Freeware
 *
 *	Charkonversionen in C-Strings
 *	lower, upper, back to 7bit
 */

#include <stdlib.h>
#include <string.h>
#include <xlb.h>

static char formcase[]="\0";

/* turn lower case chars to upper case, selfmade	*/
/* strupr in der mint-Lib ist leider etwas defekt */
char *strupper(char *s)
{
	register char *p=s;
	while (*p) {
		register char *fc=formcase;
		while (*fc) {
			if (fc[1]==*p) {
				*p++=*fc;
				break;
			}
			fc+=2;
		}
		if (!*fc) {
			if ((*p>='a') && (*p<='z'))
				*p&=(~0x20);
			p++;
		}
	}
	return s;
}

/* turn upper case chars to lower case, selfmade	*/
char *strlower(char *s)
{
	register char *p=s;
	while (*p) {
		register char *fc=formcase;
		while (*fc) {
			if (*fc==*p) {
				*p++=fc[1];
				break;
			}
			fc+=2;
		}
		if (!*fc) {
			if ((*p>='A') && (*p<='Z'))
				*p|=0x20;
			p++;
		}
	}
	return s;
}


/*	strto7bit(): turn 8Bit ATARI-ASCII-Code back to 7bit
 *	selfmade
 */

typedef struct {
	char	*from;
	char	to[4];
} FORM7BIT;

static FORM7BIT form7bit[]={
	{	"",			"="		},
	{	"",			"-"		},
	{	"",			"+-"	},
	{	"",			">="	},
	{	"",			"<="	},
	{	"",			"^"		},
	{	"",			"TM"	},
	{	"",			"'"		},
	{	"",			"<<"	},
	{	"",			">>"	},
	{	"",			"1/2"	},
	{	"",			"1/4"	},
	{	"",			";"		},
	{	"",			"?"		},
	{	"",			"AE"	},
	{	"",		"A"		},
	{	"",			"ae"	},
	{	"",	"a"		},
	{	"",			"C,"	},
	{	"",			"c,"	},
	{	"",			"c"		},
	{	"",			"E",	},
	{	"",		"e"		},
	{	"",			"f"		},
	{	"",		"i"		},
	{	"",			"L-"	},
	{	"",			"N"		},
	{	"",			"n"		},
	{	"",			"OE"	},
	{	"",			"O"		},
	{	"",			"oe"	},
	{	"",	"o"		},
	{	"",			"PI"	},
	{	"",			"ss"	},
	{	"",			"UE"	},
	{	"",			"ue"	},
	{	"",		"u"		},
	{	"",			"Y"		},
	{	"",			"y"		},
	{	NULL,			""		},
};

char *strto7bit(char *s)
{
	register char *src=malloc(strlen(s)+1);
	if (src) {
		register char *p=s;
		strcpy(src,s);
		strclr(p);
		while (*src) {
			register FORM7BIT *f=form7bit;
			boolean haveit=FALSE;
			while ((f->from) && (*f->to) && (!haveit)) {
				register char *ff=f->from;
				while ((*ff) && (!haveit)) {
					if (*ff==*src) {
						strcat(p,f->to);
						p+=strlen(f->to);
						haveit=TRUE;
					} else
						ff++;
				}
				f++;
			}
			if (!haveit) {
				*p++=(*src & 0x7F);
				*p='\0';
			}
			src++;
		}
		free(src);
	}
	return s;
}
