/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	Stringconversion
 */

#include <stdio.h>
#include <string.h>
#include <xlb.h>

/* decimal string to int, Lattice */
int stcd_i(char *in,int *ivalue)
{
	if (*in) {
		int len=0;
		sscanf(in,"%d%n",ivalue,&len);
		return len;
	}
	*ivalue=0;
	return 0;
}

/* hexadecimal string to int, Lattice */
int stch_i(char *in,int *ivalue)
{
	if (*in) {
		int len=0;
		sscanf(in,"%x%n",ivalue,&len);
		return len;
	}
	*ivalue=0;
	return 0;
}

/* decimal string to long, Lattice */
int stcd_l(char *in,long *lvalue)
{
	if (*in) {
		int len=0;
		sscanf(in,"%ld%n",lvalue,&len);
		return len;
	}
	lvalue=0L;
	return 0;
}

/* hexadecimal string to long, Lattice */
int stch_l(char *in,long *lvalue)
{
	if (*in) {
		int len=0;
		sscanf(in,"%lx%n",lvalue,&len);
		return len;
	}
	*lvalue=0L;
	return 0;
}


/* int to decimal string, Lattice */
int stci_d(char *out,int ivalue)
{
	int len=0;
	sprintf(out,"%d%n",ivalue,&len);
	return len;
}

/* unsigned int to decimal string, Lattice */
int stcu_d(char *out,unsigned int ivalue)
{
	int len=0;
	sprintf(out,"%u%n",ivalue,&len);
	return len;
}

/* int to hexadecimal string, Lattice */
int stci_h(char *out,int ivalue)
{
	int len=0;
	sprintf(out,"0x%x%n",ivalue,&len);
	return len;
}

/* int to roman string */
int stci_r(char *out,int ivalue)
{
	static char romanstr[]="IVXLCDM";
	register char *outp=out;
	if (ivalue<0) {
		*outp++='-';
		ivalue=-ivalue;
	}
	if (ivalue>3999)
		stci_d(outp,ivalue);
	else {
		short fac=1000;
		register char *rom=&romanstr[6];
		while (fac>0) {
			int val=ivalue/fac;
			if (val<=3) {
				register int ii=val;
				while (ii-->0)
					*outp++=*rom;
			} else if (val==9) {
				*outp++=*rom;
				*outp++=rom[2];
			} else {
				if (val==4)
					*outp++=*rom;
				*outp++=rom[1];
				{
					register int ii=val-5;
					while (ii-->0)
						*outp++=*rom;
				}
			}
			ivalue-=(val*fac);
			rom-=2;
			fac/=10;
		}
		*outp=0;
	}
	return (int)strlen(out);
}

/* long to decimal string, Lattice */
int stcl_d(char *out,long lvalue)
{
	int len=0;
	sprintf(out,"%ld%n",lvalue,&len);
	return len;
}

/* unsigned long to decimal string, Lattice */
int stcul_d(char *out,unsigned long lvalue)
{
	int len=0;
	sprintf(out,"%lu%n",lvalue,&len);
	return len;
}


/* long to hexadecimal string, Lattice */
int stcl_h(char *out,long lvalue)
{
	int len=0;
	sprintf(out,"0x%lx%n",lvalue,&len);
	return len;
}
