/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 05/96
 *	Public Domain / Freeware
 *
 *	Zahlenconversion, long/long long -> Zeichenkette
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <xlb.h>


/* Werte von 0 bis 19 */
static char* to20[]= {
	"null","ein","zwei","drei","vier","fnf","sechs","sieben","acht","neun",
	"zehn","elf","zwlf","dreizehn","vierzehn","fnfzehn","sechzehn","siebzehn",
	"achtzehn","neunzehn"	};

/* dekadische Werte 20-90 */
static char* dekade[] = {
	"zwanzig","dreiig","vierzig","fnfzig",
	"sechzig","siebzig","achtzig","neunzig" };

typedef struct _MAJORSTR {
	long long fact;		/* Faktor */
	char *str1;		/* Text fr 1+ oder NULL */
	char *str;		/* Text fr alles andere */
} MAJORSTR;

/* Zehnerpotenzen */
static  MAJORSTR majorstr[]= {
	{ 1E15,		"billiarde",	"billiarden"	},
	{ 1E12,		"billion",		"billionen"	},
	{	1E9,		"milliarde",	"milliarden"	},
	{	1E6,		"million",		"millionen"		},
	{	1000,				NULL,			"tausend"			},
	{	100,				NULL,			"hundert"			},
	{	1,					NULL,			""	},
	{	0,					NULL,			""	}
};

/*	Arbeitsroutine, evtl. rekursiver Aufruf	*/
static void running(long long val,char *s,MAJORSTR *majs)
{
	while (majs->fact) {
		register long long v=(val / majs->fact);
		if (v>0) {
			if (v>=100) {		/* bei allem ber Wert 100 rekursiv verfahren */
				val-=(v*majs->fact);
				running(v,s,&majs[1]);
			} else {				/* sonst den Wert schreiben */
				if (v<20) {		/* Wert von 0 bis 19 */
					strcat(s,to20[v]);
					if (v==1) {
						if (majs->str1)		/* "eine" statt "ein" */
							strcat(s,"e");
						else if (majs->fact==1)	/*	"eins" statt "ein"	*/
							strcat(s,"s");
					}
				} else {			/* Wert ber 20 */
					register int ii=(v%10);
					if (ii) {
						strcat(s,to20[ii]);
						strcat(s,"und");
					}
					strcat(s,dekade[(v/10)-2]);
				}
				val%=majs->fact;	/* geschriebenen Wert abziehen */
			}
			if ((v==1) && (majs->str1))	/* und Anhngsel schreiben */
				strcat(s,majs->str1);
			else
				strcat(s,majs->str);
		}
		majs++;
	}
}

/* long long -Wert in Zeichenkette wandeln */
int stcll_a(long long val,char *s)
{
	MAJORSTR *majs=majorstr;
	if (val==0)
		strcpy(s,*to20);
	else {
		strclr(s);
		if (val<0) {
			strcat(s,"-");
			val=-val;
		}
		running(val,s,majs);
	}
	return strlen(s);
}

/* long -Wert in Zeichenkette wandeln */
int stcl_a(long val,char *s)
{
	return stcll_a((long long)val,s);
}


/* Testroutinen: */

#ifndef __MAKE_ARCHIV__

volatile long _stksize=(10<<10);

void main(int argc,char *argv[],char *envp[])
{
	long ii;
	char s[200];
	for(ii=0;ii<=20;ii++)
	{
		/*long long val=1000000*rand()+100*rand()+rand();*/
		long long val=ii*10000+ii;
		int ll=stcll_a(val,s);
		fprintf(stdout,"%ld %d %s\n",(long)val,ll,s);
	}
}
#endif
