/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 04/96
 *	Public Domain / Freeware
 *
 *	Stringconversion fr double real
 */

#include <xlb.h>
#include <math.h>

/* decimal string to double, selfmade */
int stcd_de(char *in,double *dvalue)
{
	if (*in) {
		int len;
		sscanf(in,"%le%n",dvalue,&len);
		return len;
	}
	*dvalue=0;
	return 0;
}

/* double to decimal string, selfmade */
int stcde_d(char *out,double dvalue)
{
	int len;
	sprintf(out,"%e%n",dvalue,&len);
	return len;
}



/* bei TRUE nur bei 3er Basis Exponentenkrzel verwenden */
boolean _STCXD_NORM=FALSE;

typedef struct {
	short exp;
	char	expc;
	boolean	norm;
} EXPTYP;

static EXPTYP explist[]= {
/*	{	18,	'E',	TRUE	},	*/		/* gibt Probleme !!! */
	{	15,	'P',	TRUE	},
	{	12,	'T',	TRUE	},
	{	9,	'G',	TRUE	},
	{	6,	'M',	TRUE	},
	{	3,	'k',	TRUE	},
	{	2,	'h',	FALSE	},
	{	0,	'\0',	TRUE	},
	{	-1,	'd',	FALSE	},
	{	-2,	'c',	FALSE	},
	{	-3,	'm',	TRUE	},
	{	-6,	'',	TRUE	},
	{	-9,	'n',	TRUE	},
	{	-12,	'p',	TRUE	},
	{	-15,	'f',	TRUE	},
	{	-18,	'a',	TRUE	},
	{	-21,	'\0',	FALSE	}
};

/* extended decimal string to double, selfmade */
int stcxd_d(char *in,double *dvalue)
{
	if (*in) {
		int len;
		sscanf(in,"%le%n",dvalue,&len);
		if (in[len])
		{
			register EXPTYP *explistp=explist;
			while (explistp->exp>=-18) {
				if (explistp->expc==in[len]) {
					*dvalue*=pow(10,explistp->exp);
					len++;
					return len;
				}
				explistp++;
			}
		}
		return len;
	}
	*dvalue=0;
	return 0;
}

/* double to extended decimal string, selfmade */
int stcd_xd(char *out,double dvalue)
{
	static char exptochar(double *dval)
	{
		register EXPTYP *explistp=explist;
		short iexp;
		double dexp=log10(*dval);
		if (dexp<0)
			dexp--;
		iexp=(short) dexp;
		while (explistp->exp>=-18) {
			if ((iexp>=explistp->exp) && ((explistp->norm==TRUE) || (_STCXD_NORM==FALSE))) {
				*dval*=pow(10,-explistp->exp);
				return explistp->expc;
			}
			explistp++;
		}
		return '\0';
	}
	int len;
	char c=exptochar(&dvalue);
	sprintf(out,"%g%n",dvalue,&len);
	if (c) {
		strcatc(out,c);
		len++;
	}
	return len;
}
