/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96, 07/96
 *	Public Domain / Freeware
 *
 *	allgemeine Stringoperationen
 */

#include <stdlib.h>
#include <stdio.h>
#include <macros.h>
#include <string.h>
#include <xlb.h>

/* copy from in front of to, Lattice */
void strins(char *to,const char *from)
{
	long lfrom=strlen(from);
	long lto=strlen(to);
	/*strncpy(&to[lfrom],to,lto);*/
	memcpy(&to[lfrom],to,lto);
	to[lfrom+lto]='\0';
	/*strncpy(to,from,lfrom);*/
	memcpy(to,from,lfrom);
}

/* return a substring from a string, Lattice */
int strmid(char *src,char *dst,size_t pos,size_t len)
{
	if (pos>strlen(src))
		return -1;
	len=min(len,strlen(src)-pos);
	strncpy(dst,&src[pos],len);
	dst[len]='\0';
	return 0;
}

/* testing string pointer, selfmade */
size_t strtst(char *s)
{
	if (s==NULL)
		return 0;
	return strlen(s);
}

/* delete chars in a string, selfmade */
void strdel(char *s,int pos,int len)
{
	if (s!=NULL)
		if ((pos>=0) && (pos<=strlen(s))) {
			len=min(len,strlen(s)-pos);
			if (len>0)
				strcpy(&s[pos],&s[pos+len]);
			else
				s[pos]='\0';
		}
}

/* return pointer to last char of a string, selfmade */
char *strlastp(char *s)
{
	if (s==NULL)
		return NULL;
	if (*s=='\0')
		return s;
	return &s[strlen(s)-1];
}

/* return last char from a string, selfmade */
char strlast(char *s)
{
	register char *ret=strlastp(s);
	if (ret==NULL)
		return '\0';
	return *ret;
}

/* add character to end of string, selfmade */
void strcatc(char *dst,char c)
{
	if (strlast(dst)!=c) {
		char si[2]={c,'\0'};
		strcat(dst,si);
	}
}

/* add character and string to end of string, selfmade */
void strcatcs(char *dst,char c,char *src)
{
	char *p=src;
	strcatc(dst,c);
	if (p[0]==c)
		p++;
	strcat(dst,p);
}

/* clear spaces and tabs left and right of string, selfmade	*/
char *strtrim(char *s)
{
	char *start=s,*end=strlastp(s);
	while ((*start==' ') || (*start=='\t'))
		start++;
	end--;
	while ((*end==' ') || (*end=='\t'))
		end--;
	end++;
	if (end>start) {
		strclr(end);
		if (start>s)
			strdel(s,0,start-s);
	} else
		strclr(s);
	return s;
}
