/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96
 *	Public Domain / Freeware
 *
 *	String-Pfad-Manipulationen
 */

#include <string.h>
#include <xlb.h>

/* get file extension from full pathname, Lattice */
int stcgfe(char *ext,char *name)
{
	char *pp=strrchr(name,'.');
	char *ps=strrchr(name,'\\');
	ext[0]='\0';
	if ((pp!=NULL) && ((ps==NULL) || ((ps!=NULL) && (pp>ps) && (ps<&name[strlen(name)]))))
		strcpy(ext,pp+1);
	return (strlen(ext));
}

/* get filenode from full pathname, Lattice */
int stcgfn(char *node,char *name)
{
	char *lsl=strrchr(name,'\\');
	if (lsl==NULL)
		lsl=strrchr(name,':');
	if (lsl==NULL)
		lsl=name-1;
	node[0]='\0';
	if ((lsl!=NULL) && (lsl<&name[strlen(name)]))
		strcpy(node,lsl+1);
	return strlen(node);
}

/* get filepath from full pathname, Lattice */
int stcgfp(char *path,char *name)
{
	char *lsl;
	if (path!=name)
		strcpy(path,name);
	lsl=strrchr(path,'\\');
	if (lsl!=NULL)
		*++lsl='\0';
	else if (path[1]==':')
		path[2]='\0';
	else
		*path='\0';
	return strlen(path);
}

/* get filepath without extension, selfmade */
int stcwoe(char *woe,char *name)
{
	char *lp,*lsl;
	if (woe!=name)
		strcpy(woe,name);
	lp=strrchr(woe,'.');
	lsl=strrchr(woe,'\\');
	if ((lp!=NULL) && (lp>lsl))
		*lp='\0';
	return strlen(woe);
}

/* make file name with extension, Lattice */
void strmfe(char *newname,char *oldname,char *ext)
{
	strcpy(newname,oldname);
	if (strlen(ext)) {
		strcat(newname,".");
		strcat(newname,ext);
	}
}

/* make file name from path and node, Lattice */
void strmfp(char *name,char *path,char *node)
{
	strcpy(name,path);
	if (path[strlen(name)]!='\\')
		strcat(name,"\\");
	strcat(name,node);
}

/* make file name from components, Lattice */
void strmfn(char *file,char *drive,char *path,char *node,char *ext)
{
	file[0]='\0';
	if (strtst(drive))
		strcat(file,drive);
	if (strtst(path)) {
		if (file[1]!=':')
			strcat(file,":");
		strcatcs(file,'\\',path);
	}
	if (strtst(node))
		strcatcs(file,'\\',node);
	if (strtst(ext))
		strcatcs(file,'.',ext);
}

/* split file name, Lattice */
void strsfn(char *file,char *drive,char *path,char *node,char *ext)
{
	stcgfe(ext,file);
	stcgfn(node,file);
	stcwoe(node,node);
	stcgfp(path,file);
	drive[0]='\0';
	if (path[1]==':') {
		strncpy(drive,path,2);
		drive[2]='\0';
		strcpy(path,&path[2]);
		if (strlen(path)==1)
			path[0]='\0';
	}
}
