/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 04/96
 *	Public Domain / Freeware
 *
 *	BIOS- und DOS-Fehlernummern zum String wandeln
 */

#include <osbind.h>
#include <xlb.h>

typedef struct {
	long nr;
	char *str;
} ERRTYP;

static ERRTYP syserrors[]={
	{	0,	"OK (no error)"	},
/* BIOS- und XBIOS-Fehlermeldungen */
	{	-1,	"Error"	},
	{	-2,	"Drive not ready"	},
	{	-3,	"Unkonown command" },
	{	-4,	"CRC error"	},
	{	-5,	"Bad request"	},
	{	-6,	"Seek eror"	},
	{	-7,	"Unknown media"	},
	{	-8,	"Sector not found" },
	{	-9,	"Out of paper"	},
	{	-10,	"Write fault"	},
	{	-11,	"Read fault"	},
	{	-12,	"General error"	},
	{	-13,	"Write on write-protected media"	},
	{	-14,	"Media change detected"	},
	{	-15,	"Unknown device"	},
	{	-16,	"Bad sectors on format"	},
	{	-17,	"Insert other disk request"	},
	{	-18,	"Insert disk"	},
	{	-19,	"Device not responding"	},
/* GEMDOS-Fehlermeldungen */
	{	-32,	"Invalid function number"	},
	{	-33,	"File not found"	},
	{	-34,	"Path not found"	},
	{	-35,	"Handle pool exhausted"	},
	{	-36,	"Access denied"	},
	{	-37,	"Invalid handle"	},
	{	-39,	"Insufficient memory"	},
	{	-40,	"Invalid memory block address"	},
	{	-46,	"Invalid drive specification"	},
	{	-48,	"Not the same drive"	},
	{	-49,	"No more files"	},
	{	-58,	"Record is locked"	},
	{	-59,	"No such lock"	},
	{	-64,	"Range error"	},
	{	-65,	"GEMDOS internal error"	},
	{	-66,	"Invalid executable file format"	},
	{	-67,	"Memory block growth failure"	},
	{	0,	""	}
};

char *syserr(long errnr)
{
	register ERRTYP* err=syserrors;
	while (*err->str) {
		if (err->nr==errnr)
			return err->str;
		err++;
	}
	return "";
}
