/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96, 01/97
 *	Public Domain / Freeware
 *
 *	erweiterte AES-Fensterfunktionen
 */

#include <xlb.h>

/* Neuzeichnen eines Fensterbereiches mit VDI-Clipping und
	einem spezifischen Parameter */
void wind_xredraw(int handle,int vhandle,long par,
		GRECT *r,GRECT* rw,void (*routine)(int handle,long par,GRECT *p))
{
	GRECT rect1,rect;
	int hidem;
//	rc_copy(r,&rect);
	rect=*r;
	if (handle>0) {
		wind_gget(0,WF_WORKXYWH,&rect1);
		if (rc_intersect(&rect,&rect1))
		{
			if (rw!=NULL)
				//rc_copy(rw,&rect);
				rect=*rw;
			else
				wind_gget(handle,WF_WORKXYWH,&rect);
			if (rc_intersect(&rect,&rect1)) {
				begin_update();
				hidem=hide_mouse_inside(&rect1);
				wind_gget(handle,WF_FIRSTXYWH,&rect);
				while ((rect.g_w>0) && (rect.g_h>0)) {
					if (rc_intersect(&rect1,&rect)) {
						if (vhandle>0)
							vs_gclip(vhandle,&rect);
						routine(handle,par,&rect);
						if (vhandle>0)
							vs_clipoff(vhandle);
					}
					wind_gget(handle,WF_NEXTXYWH,&rect);
				}
				if (hidem)
					show_mouse();
				end_update();
			}
		}
	}
}


/* Bereich neu zeichnen lassen, besonders bei popups */
	static void wformdraw(int whandle,GRECT *wrect)
	{
		form_gdial(FMD_FINISH,0L,wrect);
	}
void form_wredraw(int handle,GRECT *r)
{
	GRECT rect1,rect;
	rc_copy(r,&rect);
	if (handle>=0) {
		wind_gget(handle,WF_WORKXYWH,&rect1);
		if ((rect.g_x<=0) && (rect.g_y<=0) && (rect.g_w<=0) && (rect.g_h<=0))
			rc_copy(&rect1,&rect);
		/* neu zu zeichnender Bereich liegt auerhalb des Fensters */
		if ((rect.g_x<rect1.g_x) || (rect.g_y<rect1.g_y)
				|| (rect.g_x+rect.g_w>rect1.g_x+rect1.g_w) || (rect.g_y+rect.g_h>rect1.g_y+rect1.g_h))
			form_gdial(FMD_FINISH,0L,&rect);
		else	/* neu zu zeichnender Bereich liegt innerhalb des Fensters */
			wind_redraw(handle,&rect,wformdraw);
	}
}


/* Objekt in einem Fenster neu zeichnen */
	typedef struct
	{
		OBJECT *tree;
		int ob;
	} TREEOB;
	static void wobjcdraw(int whandle,long par,GRECT *wrect)
	{
		register TREEOB* t=(TREEOB*)par;
		objc_gdraw(t->tree,t->ob,-1,wrect);
	}
void wind_objcredraw(int handle,int vhandle,OBJECT *tree,int ob)
{
	if ((handle>0) && (tree!=NULL)) {
		GRECT rect;
		TREEOB to;
		to.tree=tree;
		to.ob=ob;
		objc_xywh(tree,ob,&rect);
		wind_xredraw(handle,vhandle,(long)&to,&rect,NULL,wobjcdraw);
	}
}

/* Objekt in einem Fenster neu zeichnen und Status ndern */
	typedef struct
	{
		OBJECT *tree;
		int ob;
		unsigned short oldstate;
		unsigned short newstate;
	} TREEOBS;
	static void wobjcdrawstate(int whandle,long par,GRECT *wrect)
	{
		register TREEOBS* t=(TREEOBS*)par;
		t->tree[t->ob].ob_state=t->oldstate;
		objc_gchange(t->tree,t->ob,wrect,t->newstate);
	}
void wind_objcchangeredraw(int handle,int vhandle,OBJECT *tree,int ob,boolean state)
{
	if ((handle>0) && (tree!=NULL))
	{
		GRECT rect;
		TREEOBS to;
		to.tree=tree;
		to.ob=ob;
		to.oldstate=tree[ob].ob_state;
		to.newstate=state?SELECTED:0;
		objc_xywh(tree,ob,&rect);
		wind_xredraw(handle,vhandle,(long)&to,&rect,NULL,wobjcdrawstate);
	}
}
