/*
 *	eXtended-Library
 *	released for GNU-C
 *	by Volker Hemsen, 03/96, 01/97
 *	Public Domain / Freeware
 *
 *	erweiterte AES-Fensterfunktionen
 */

#include <macros.h>
#include <xlb.h>

/* wie wind_calc(), nur mit GRECT */
void wind_gcalc(int wctype,int kind,const GRECT *rect1,GRECT *rect2)
{
	wind_calc(wctype,kind,rect1->g_x,rect1->g_y,rect1->g_w,rect1->g_h,
					&rect2->g_x,&rect2->g_y,&rect2->g_w,&rect2->g_h);
}

/* wie wind_get() nur mit GRECT */
void wind_gget(int handle,int field,GRECT *rect)
{
	wind_get(handle,field,&rect->g_x,&rect->g_y,&rect->g_w,&rect->g_h);
}

/* wie wind_set(), nur mit GRECT */
void wind_gset(int handle,int field,const GRECT *rect)
{
	wind_set(handle,field,rect->g_x,rect->g_y,rect->g_w,rect->g_h);
}

/* wie wind_create(), nur mit GRECT */
int wind_gcreate(int kind,GRECT *rect)
{
	GRECT rectx;
	if (!rect) {
		wind_gget(0,WF_WORKXYWH,&rectx);
		rect=&rectx;
	}
	return wind_create(kind,rect->g_x,rect->g_y,rect->g_w,rect->g_h);
}

/* wie wind_open(), nur mit GRECT */
int wind_gopen(int handle,GRECT *rect)
{
	return wind_open(handle,rect->g_x,rect->g_y,rect->g_w,rect->g_h);
}

/* wie form_dial(), nur mit GRECT */
void form_gdial(int flag,GRECT *rect1,GRECT *rect2)
{
	GRECT x={0,0,0,0};
	if (!rect1)
		rect1=&x;
	if (!rect2)
		rect2=&x;
	form_dial(flag,rect1->g_x,rect1->g_y,rect1->g_w,rect1->g_h,
		rect2->g_x,rect2->g_y,rect2->g_w,rect2->g_h);
}

/* wie form_center(), nur mit GRECT */
void form_gcenter(OBJECT* pt,GRECT* r)
{
	form_center(pt,&r->g_x,&r->g_y,&r->g_w,&r->g_h);
}

/* wie objc_draw(), nur mit GRECT */
void objc_gdraw(OBJECT* tree,int objc,int depth,GRECT* rec)
{
	objc_draw(tree,objc,((depth>=0)?(depth):(MAX_DEPTH)),rec->g_x,rec->g_y,rec->g_w,rec->g_h);
}

/* wie objc_change(), nur mit GRECT */
void objc_gchange(OBJECT* tree,short objc,GRECT* rec,unsigned short newstate)
{
	objc_change(tree,objc,0,rec->g_x,rec->g_y,rec->g_w,rec->g_h,newstate,1);
}

