/*  getpwuid.c -- MiNTLib.
    Copyright (C) 1999 Guido Flohr <gufl0000@stud.uni-sb.de>

    This file is part of the MiNTLib project, and may only be used
    modified and distributed under the terms of the MiNTLib project
    license, COPYMINT.  By continuing to use, modify, or distribute
    this file you indicate that you have read the license and
    understand and accept it fully.
*/

#include <pwd.h>
#include <errno.h>

#ifndef HAVE_WEAK_SYMBOLS
# define __getpwuid_r(uid, result_buf, buffer, buflen, result) \
  getpwuid_r(uid, result_buf, buffer, buflen, result)
#endif

__EXTERN int __getpwuid_r __PROTO ((uid_t uid, struct passwd* result_buf,
                                    char* buffer, size_t buflen,
                                    struct passwd** result));
static struct passwd passwd;
static char buf[1024];

struct passwd* getpwuid (uid_t uid)
{
  struct passwd* result;
  
  if (__getpwuid_r (uid, &passwd, buf, 1024, &result) != 0)
    return NULL;
  return result;
}
