/* sigaction() and sigset functions for MiNT; placed in the public domain */

#include <errno.h>
#include <mintbind.h>
#include <signal.h>

int
sigprocmask(how, set, oset)
  int how;
  const sigset_t *set;
  sigset_t *oset;
{
  int rv = 0;
  long omask = 0L;

  if (!set) {
    errno = EINVAL;
    return -1;
  }
  switch (how) {
    case SIG_BLOCK:
      omask = Psigblock(set->__sigset_data[0]);
      break;
    case SIG_UNBLOCK:
      omask = Psigblock(0L);
      (void) Psigsetmask(omask & ~(set->__sigset_data[0]));
      break;
    case SIG_SETMASK:
      omask = Psigsetmask(set->__sigset_data[0]);
      break;
    default:
      errno = EINVAL;
      rv = -1;
  }
  if (oset) oset->__sigset_data[0] = omask;
  return rv;
}
